"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.errors = void 0;
exports.errors = {
    "0x91f53656": {
        "err": "PriceError",
        "explain": "price error"
    },
    "0xf425628d": {
        "err": "RedemptionSignerNotInitialized",
        "explain": "redemption signer not initialized"
    },
    "0xb0d4232c": {
        "err": "NotEnoughForSeize",
        "explain": "not enough for seize"
    },
    "0xa31ab54a": {
        "err": "NoRedemptionProvider",
        "explain": "no redemption provider"
    },
    "0x69609fc6": {
        "err": "MarketNotListed",
        "explain": "market not listed"
    },
    "0x095bf333": {
        "err": "InsufficientShortfall",
        "explain": "insufficient shortfall"
    },
    "0xe46c1559": {
        "err": "TooMuchRepay",
        "explain": "too much repay"
    },
    "0x5012e145": {
        "err": "InvalidMinSuBorrowValue",
        "explain": "invalid min su borrow value"
    },
    "0x52688730": {
        "err": "BorrowValueMustBeLargerThanThreshold(uint256 usdThreshold)",
        "explain": "borrow value must be larger than threshold(uint256 usd threshold)"
    },
    "0x4d5eeb49": {
        "err": "MarketAlreadyListed",
        "explain": "market already listed"
    },
    "0xe6c4247b": {
        "err": "InvalidAddress",
        "explain": "invalid address"
    },
    "0x368e710a": {
        "err": "InvalidGroupId",
        "explain": "invalid group id"
    },
    "0xee0bdbdf": {
        "err": "InvalidCloseFactor",
        "explain": "invalid close factor"
    },
    "0x1ee5e656": {
        "err": "InvalidSuToken",
        "explain": "invalid su token"
    },
    "0x4be6321b": {
        "err": "InvalidSignatureLength",
        "explain": "invalid signature length"
    },
    "0xdf4cc36d": {
        "err": "ExpiredSignature",
        "explain": "expired signature"
    },
    "0x2534adb4": {
        "err": "SenderMustBeCToken",
        "explain": "sender must be c token"
    },
    "0xd7d248ba": {
        "err": "MintPaused",
        "explain": "mint paused"
    },
    "0x12b0cb46": {
        "err": "BorrowPaused",
        "explain": "borrow paused"
    },
    "0xcd1fda9f": {
        "err": "TransferPaused",
        "explain": "transfer paused"
    },
    "0x0fe80ef6": {
        "err": "SeizePaused",
        "explain": "seize paused"
    },
    "0x3a23d825": {
        "err": "InsufficientCollateral",
        "explain": "insufficient collateral"
    },
    "0xa87fd01e": {
        "err": "EitherAssetOrDebtMustBeZeroInGroup",
        "explain": "either asset or debt must be zero in group"
    },
    "0x3bcdab6b": {
        "err": "EitherAssetOrDebtMustBeZero",
        "explain": "either asset or debt must be zero"
    },
    "0xe8e849b0": {
        "err": "OnlyAdminOrPauser",
        "explain": "only admin or pauser"
    },
    "0x47556579": {
        "err": "OnlyAdmin",
        "explain": "only admin"
    },
    "0xd1ec4b23": {
        "err": "OnlyPendingAdmin",
        "explain": "only pending admin"
    },
    "0x67a3563f": {
        "err": "OnlyRedemptionManager",
        "explain": "only redemption manager"
    },
    "0x41554b63": {
        "err": "OnlyListedCToken",
        "explain": "only listed c token"
    },
    "0x31c57596": {
        "err": "OnlyCToken",
        "explain": "only c token"
    },
    "0x8ddb9aa6": {
        "err": "UnderlyingBalanceError",
        "explain": "underlying balance error"
    },
    "0x47435475": {
        "err": "MarketCanOnlyInitializeOnce",
        "explain": "market can only initialize once"
    },
    "0x2f028cfb": {
        "err": "CantSweepUnderlying",
        "explain": "cant sweep underlying"
    },
    "0xcaab38a0": {
        "err": "TokenTransferInFailed",
        "explain": "token transfer in failed"
    },
    "0xe610f326": {
        "err": "TokenTransferOutFailed",
        "explain": "token transfer out failed"
    },
    "0x8cd22d19": {
        "err": "TransferNotAllowed",
        "explain": "transfer not allowed"
    },
    "0x431f269d": {
        "err": "TokenInOrAmountInMustBeZero",
        "explain": "token in or amount in must be zero"
    },
    "0xd725cf1c": {
        "err": "AddReservesOverflow",
        "explain": "add reserves overflow"
    },
    "0x91240a1b": {
        "err": "RedeemTransferOutNotPossible",
        "explain": "redeem transfer out not possible"
    },
    "0x48c25881": {
        "err": "BorrowCashNotAvailable",
        "explain": "borrow cash not available"
    },
    "0x3345e999": {
        "err": "ReduceReservesCashNotAvailable",
        "explain": "reduce reserves cash not available"
    },
    "0x2977522e": {
        "err": "InvalidDiscountRate",
        "explain": "invalid discount rate"
    },
    "0xa2ec3a55": {
        "err": "InvalidExchangeRate",
        "explain": "invalid exchange rate"
    },
    "0x548497dc": {
        "err": "InvalidReduceAmount",
        "explain": "invalid reduce amount"
    },
    "0x373792d2": {
        "err": "InvalidReserveFactor",
        "explain": "invalid reserve factor"
    },
    "0x83aebebd": {
        "err": "InvalidComptroller",
        "explain": "invalid comptroller"
    },
    "0xee39b725": {
        "err": "InvalidInterestRateModel",
        "explain": "invalid interest rate model"
    },
    "0x2c5211c6": {
        "err": "InvalidAmount",
        "explain": "invalid amount"
    },
    "0xb4fa3fb3": {
        "err": "InvalidInput",
        "explain": "invalid input"
    },
    "0x015f7140": {
        "err": "BorrowAndDepositBackFailed",
        "explain": "borrow and deposit back failed"
    },
    "0x4702195f": {
        "err": "InvalidSignatureForRedeemFaceValue",
        "explain": "invalid signature for redeem face value"
    },
    "0x53977d1f": {
        "err": "BorrowCapReached",
        "explain": "borrow cap reached"
    },
    "0xa9b65aba": {
        "err": "SupplyCapReached",
        "explain": "supply cap reached"
    },
    "0x0c73eb05": {
        "err": "ComptrollerMismatch",
        "explain": "comptroller mismatch"
    },
    "0x3393b257": {
        "err": "MintMarketNotFresh",
        "explain": "mint market not fresh"
    },
    "0xa42bc390": {
        "err": "BorrowMarketNotFresh",
        "explain": "borrow market not fresh"
    },
    "0xc714a2d5": {
        "err": "RepayBorrowMarketNotFresh",
        "explain": "repay borrow market not fresh"
    },
    "0xa17754ef": {
        "err": "RedeemMarketNotFresh",
        "explain": "redeem market not fresh"
    },
    "0xfbf3ea79": {
        "err": "LiquidateMarketNotFresh",
        "explain": "liquidate market not fresh"
    },
    "0x7d10c4f6": {
        "err": "LiquidateCollateralMarketNotFresh",
        "explain": "liquidate collateral market not fresh"
    },
    "0x5d1f8c0c": {
        "err": "ReduceReservesMarketNotFresh",
        "explain": "reduce reserves market not fresh"
    },
    "0x7b964b3b": {
        "err": "SetInterestRateModelMarketNotFresh",
        "explain": "set interest rate model market not fresh"
    },
    "0x9d4e8c1b": {
        "err": "AddReservesMarketNotFresh",
        "explain": "add reserves market not fresh"
    },
    "0xf68a5d02": {
        "err": "SetReservesFactorMarketNotFresh",
        "explain": "set reserves factor market not fresh"
    },
    "0xd2722928": {
        "err": "CantExitMarketWithNonZeroBorrowBalance",
        "explain": "cant exit market with non zero borrow balance"
    },
    "0xb7d09497": {
        "err": "InvalidTimestamp",
        "explain": "invalid timestamp"
    },
    "0xee366600": {
        "err": "NotCToken",
        "explain": "not c token"
    },
    "0x4a8af12d": {
        "err": "NotSuToken",
        "explain": "not su token"
    },
    "0xb2f72f47": {
        "err": "LiquidateBorrow_RepayAmountIsZero",
        "explain": "liquidate borrow repay amount is zero"
    },
    "0xf72ef4e1": {
        "err": "LiquidateBorrow_RepayAmountIsMax",
        "explain": "liquidate borrow repay amount is max"
    },
    "0x73f0c360": {
        "err": "LiquidateBorrow_LiquidatorIsBorrower",
        "explain": "liquidate borrow liquidator is borrower"
    },
    "0x1cf449d6": {
        "err": "LiquidateBorrow_SeizeTooMuch",
        "explain": "liquidate borrow seize too much"
    },
    "0x7a2d3db3": {
        "err": "Seize_LiquidatorIsBorrower",
        "explain": "seize liquidator is borrower"
    },
    "0x7ccfa2dc": {
        "err": "ProtectedMint_OnlyAllowAssetsInTheSameGroup",
        "explain": "protected mint only allow assets in the same group"
    },
    "0x3885b26c": {
        "err": "RedemptionSeizeTooMuch",
        "explain": "redemption seize too much"
    },
    "0x4cc0487d": {
        "err": "MinDelayNotReached",
        "explain": "min delay not reached"
    },
    "0xd26a7d5f": {
        "err": "NotLiquidatableYet",
        "explain": "not liquidatable yet"
    },
    "0x4e47846c": {
        "err": "InvalidBlockNumber",
        "explain": "invalid block number"
    },
    "0x8579befe": {
        "err": "ZeroAddressNotAllowed",
        "explain": "zero address not allowed"
    },
    "0x9725942a": {
        "err": "BucketOverfilled",
        "explain": "bucket overfilled"
    },
    "0xf6cd5620": {
        "err": "OnlyCallableByAdminOrOwner",
        "explain": "only callable by admin or owner"
    },
    "0xc289aafd": {
        "err": "TokenMaxCapacityExceeded(uint256 capacity, uint256 requested, address tokenAddress)",
        "explain": "token max capacity exceeded(uint256 capacity, uint256 requested, address token address)"
    },
    "0x1795b1ca": {
        "err": "TokenRateLimitReached(uint256 minWaitInSeconds, uint256 available, address tokenAddress)",
        "explain": "token rate limit reached(uint256 min wait in seconds, uint256 available, address token address)"
    },
    "0x72076a61": {
        "err": "AggregateValueMaxCapacityExceeded(uint256 capacity, uint256 requested)",
        "explain": "aggregate value max capacity exceeded(uint256 capacity, uint256 requested)"
    },
    "0xc543c3b0": {
        "err": "AggregateValueRateLimitReached(uint256 minWaitInSeconds, uint256 available)",
        "explain": "aggregate value rate limit reached(uint256 min wait in seconds, uint256 available)"
    },
    "0xcdb8b6a8": {
        "err": "InvalidRatelimitRate(Config rateLimiterConfig)",
        "explain": "invalid ratelimit rate( config rate limiter config)"
    },
    "0xf814b583": {
        "err": "DisabledNonZeroRateLimit(Config config)",
        "explain": "disabled non zero rate limit( config config)"
    },
    "0x433fc33d": {
        "err": "RateLimitMustBeDisabled",
        "explain": "rate limit must be disabled"
    },
    "0x9cf8540c": {
        "err": "ZeroValueNotAllowed",
        "explain": "zero value not allowed"
    },
    "0x332e58c0": {
        "err": "EmptyPythOracle; // thrown when pythOracle is empt",
        "explain": "empty pyth oracle; // thrown when pyth oracle is empt"
    },
    "0x019b3b2d": {
        "err": "EmptyPendlePtOracle; // thrown when pendlePtOralce is empt",
        "explain": "empty pendle pt oracle; // thrown when pendle pt oralce is empt"
    },
    "0x19357c8f": {
        "err": "UnknownSource; // thrown when source is unknown during getPric",
        "explain": "unknown source; // thrown when source is unknown during get pric"
    },
    "0xa30c6e5f": {
        "err": "UnsupportedSource; // thrown when source is not supported during getPric",
        "explain": "unsupported source; // thrown when source is not supported during get pric"
    },
    "0xda0623a1": {
        "err": "InvalidFeedDecimals",
        "explain": "invalid feed decimals"
    },
    "0x8dad094a": {
        "err": "EmptyFeedAddress",
        "explain": "empty feed address"
    },
    "0xd7e65e70": {
        "err": "EmptyAdapterAddress",
        "explain": "empty adapter address"
    },
    "0x061624df": {
        "err": "EmptyMaxStalePeriod",
        "explain": "empty max stale period"
    },
    "0x512760af": {
        "err": "InvalidPrice; // thrown when price is ",
        "explain": "invalid price; // thrown when price is"
    },
    "0x1a8fefc3": {
        "err": "NoEnoughReward",
        "explain": "no enough reward"
    }
};
//# sourceMappingURL=errors.js.map