import type { BaseContract, BigNumberish, BytesLike, FunctionFragment, Result, Interface, AddressLike, ContractRunner, ContractMethod, Listener } from "ethers";
import type { TypedContractEvent, TypedDeferredTopicFilter, TypedEventLog, TypedListener, TypedContractMethod } from "../../../../common";
export interface IFlashLoanRecipientInterface extends Interface {
    getFunction(nameOrSignature: "receiveFlashLoan"): FunctionFragment;
    encodeFunctionData(functionFragment: "receiveFlashLoan", values: [AddressLike[], BigNumberish[], BigNumberish[], BytesLike]): string;
    decodeFunctionResult(functionFragment: "receiveFlashLoan", data: BytesLike): Result;
}
export interface IFlashLoanRecipient extends BaseContract {
    connect(runner?: ContractRunner | null): IFlashLoanRecipient;
    waitForDeployment(): Promise<this>;
    interface: IFlashLoanRecipientInterface;
    queryFilter<TCEvent extends TypedContractEvent>(event: TCEvent, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TypedEventLog<TCEvent>>>;
    queryFilter<TCEvent extends TypedContractEvent>(filter: TypedDeferredTopicFilter<TCEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TypedEventLog<TCEvent>>>;
    on<TCEvent extends TypedContractEvent>(event: TCEvent, listener: TypedListener<TCEvent>): Promise<this>;
    on<TCEvent extends TypedContractEvent>(filter: TypedDeferredTopicFilter<TCEvent>, listener: TypedListener<TCEvent>): Promise<this>;
    once<TCEvent extends TypedContractEvent>(event: TCEvent, listener: TypedListener<TCEvent>): Promise<this>;
    once<TCEvent extends TypedContractEvent>(filter: TypedDeferredTopicFilter<TCEvent>, listener: TypedListener<TCEvent>): Promise<this>;
    listeners<TCEvent extends TypedContractEvent>(event: TCEvent): Promise<Array<TypedListener<TCEvent>>>;
    listeners(eventName?: string): Promise<Array<Listener>>;
    removeAllListeners<TCEvent extends TypedContractEvent>(event?: TCEvent): Promise<this>;
    receiveFlashLoan: TypedContractMethod<[
        tokens: AddressLike[],
        amounts: BigNumberish[],
        feeAmounts: BigNumberish[],
        userData: BytesLike
    ], [
        void
    ], "nonpayable">;
    getFunction<T extends ContractMethod = ContractMethod>(key: string | FunctionFragment): T;
    getFunction(nameOrSignature: "receiveFlashLoan"): TypedContractMethod<[
        tokens: AddressLike[],
        amounts: BigNumberish[],
        feeAmounts: BigNumberish[],
        userData: BytesLike
    ], [
        void
    ], "nonpayable">;
    filters: {};
}
