import type { BaseContract, BigNumberish, BytesLike, FunctionFragment, Result, Interface, EventFragment, AddressLike, ContractRunner, ContractMethod, Listener } from "ethers";
import type { TypedContractEvent, TypedDeferredTopicFilter, TypedEventLog, TypedLogDescription, TypedListener, TypedContractMethod } from "../../common";
export interface RedemptionManagerInterface extends Interface {
    getFunction(nameOrSignature: "BETA" | "DECIMAL_PRECISION" | "DEFAULT_ADMIN_ROLE" | "MAX_BORROWING_FEE" | "MINUTE_DECAY_FACTOR" | "REDEMPTION_FEE_FLOOR" | "SECONDS_IN_ONE_MINUTE" | "baseRate" | "baseRateMap" | "calcActualRepayAndSeize" | "comptroller" | "decayBaseRateFromBorrowing" | "getCurrentRedemptionRate" | "getRedemptionRate" | "getRoleAdmin" | "getRoleMember" | "getRoleMemberCount" | "grantRole" | "hasRole" | "initialize" | "lastFeeOperationTime" | "lastFeeOperationTimeMap" | "redeemFaceValue" | "redeemFaceValueWithPermit" | "redeemFaceValueWithProviderPreview" | "redemptionSigner" | "renounceRole" | "revokeRole" | "setComptroller" | "setRedemptionSigner" | "supportsInterface"): FunctionFragment;
    getEvent(nameOrSignatureOrTopic: "BaseRateUpdated" | "Initialized" | "LastFeeOpTimeUpdated" | "NewComptroller" | "NewRedemptionSigner" | "RoleAdminChanged" | "RoleGranted" | "RoleRevoked"): EventFragment;
    encodeFunctionData(functionFragment: "BETA", values?: undefined): string;
    encodeFunctionData(functionFragment: "DECIMAL_PRECISION", values?: undefined): string;
    encodeFunctionData(functionFragment: "DEFAULT_ADMIN_ROLE", values?: undefined): string;
    encodeFunctionData(functionFragment: "MAX_BORROWING_FEE", values?: undefined): string;
    encodeFunctionData(functionFragment: "MINUTE_DECAY_FACTOR", values?: undefined): string;
    encodeFunctionData(functionFragment: "REDEMPTION_FEE_FLOOR", values?: undefined): string;
    encodeFunctionData(functionFragment: "SECONDS_IN_ONE_MINUTE", values?: undefined): string;
    encodeFunctionData(functionFragment: "baseRate", values?: undefined): string;
    encodeFunctionData(functionFragment: "baseRateMap", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "calcActualRepayAndSeize", values: [BigNumberish, AddressLike, AddressLike, AddressLike]): string;
    encodeFunctionData(functionFragment: "comptroller", values?: undefined): string;
    encodeFunctionData(functionFragment: "decayBaseRateFromBorrowing", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "getCurrentRedemptionRate", values: [AddressLike, BigNumberish, BigNumberish]): string;
    encodeFunctionData(functionFragment: "getRedemptionRate", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "getRoleAdmin", values: [BytesLike]): string;
    encodeFunctionData(functionFragment: "getRoleMember", values: [BytesLike, BigNumberish]): string;
    encodeFunctionData(functionFragment: "getRoleMemberCount", values: [BytesLike]): string;
    encodeFunctionData(functionFragment: "grantRole", values: [BytesLike, AddressLike]): string;
    encodeFunctionData(functionFragment: "hasRole", values: [BytesLike, AddressLike]): string;
    encodeFunctionData(functionFragment: "initialize", values: [AddressLike, AddressLike]): string;
    encodeFunctionData(functionFragment: "lastFeeOperationTime", values?: undefined): string;
    encodeFunctionData(functionFragment: "lastFeeOperationTimeMap", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "redeemFaceValue", values: [AddressLike, BigNumberish, AddressLike[], BigNumberish, BytesLike]): string;
    encodeFunctionData(functionFragment: "redeemFaceValueWithPermit", values: [
        AddressLike,
        BigNumberish,
        AddressLike[],
        BigNumberish,
        BytesLike,
        BigNumberish,
        BytesLike
    ]): string;
    encodeFunctionData(functionFragment: "redeemFaceValueWithProviderPreview", values: [
        AddressLike,
        AddressLike,
        AddressLike,
        AddressLike,
        BigNumberish,
        BigNumberish
    ]): string;
    encodeFunctionData(functionFragment: "redemptionSigner", values?: undefined): string;
    encodeFunctionData(functionFragment: "renounceRole", values: [BytesLike, AddressLike]): string;
    encodeFunctionData(functionFragment: "revokeRole", values: [BytesLike, AddressLike]): string;
    encodeFunctionData(functionFragment: "setComptroller", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "setRedemptionSigner", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "supportsInterface", values: [BytesLike]): string;
    decodeFunctionResult(functionFragment: "BETA", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "DECIMAL_PRECISION", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "DEFAULT_ADMIN_ROLE", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "MAX_BORROWING_FEE", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "MINUTE_DECAY_FACTOR", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "REDEMPTION_FEE_FLOOR", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "SECONDS_IN_ONE_MINUTE", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "baseRate", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "baseRateMap", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "calcActualRepayAndSeize", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "comptroller", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "decayBaseRateFromBorrowing", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getCurrentRedemptionRate", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getRedemptionRate", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getRoleAdmin", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getRoleMember", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getRoleMemberCount", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "grantRole", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "hasRole", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "initialize", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "lastFeeOperationTime", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "lastFeeOperationTimeMap", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "redeemFaceValue", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "redeemFaceValueWithPermit", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "redeemFaceValueWithProviderPreview", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "redemptionSigner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "renounceRole", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "revokeRole", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setComptroller", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setRedemptionSigner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "supportsInterface", data: BytesLike): Result;
}
export declare namespace BaseRateUpdatedEvent {
    type InputTuple = [asset: AddressLike, _baseRate: BigNumberish];
    type OutputTuple = [asset: string, _baseRate: bigint];
    interface OutputObject {
        asset: string;
        _baseRate: bigint;
    }
    type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
    type Filter = TypedDeferredTopicFilter<Event>;
    type Log = TypedEventLog<Event>;
    type LogDescription = TypedLogDescription<Event>;
}
export declare namespace InitializedEvent {
    type InputTuple = [version: BigNumberish];
    type OutputTuple = [version: bigint];
    interface OutputObject {
        version: bigint;
    }
    type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
    type Filter = TypedDeferredTopicFilter<Event>;
    type Log = TypedEventLog<Event>;
    type LogDescription = TypedLogDescription<Event>;
}
export declare namespace LastFeeOpTimeUpdatedEvent {
    type InputTuple = [asset: AddressLike, timestamp: BigNumberish];
    type OutputTuple = [asset: string, timestamp: bigint];
    interface OutputObject {
        asset: string;
        timestamp: bigint;
    }
    type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
    type Filter = TypedDeferredTopicFilter<Event>;
    type Log = TypedEventLog<Event>;
    type LogDescription = TypedLogDescription<Event>;
}
export declare namespace NewComptrollerEvent {
    type InputTuple = [
        oldComptroller: AddressLike,
        newComptroller: AddressLike
    ];
    type OutputTuple = [oldComptroller: string, newComptroller: string];
    interface OutputObject {
        oldComptroller: string;
        newComptroller: string;
    }
    type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
    type Filter = TypedDeferredTopicFilter<Event>;
    type Log = TypedEventLog<Event>;
    type LogDescription = TypedLogDescription<Event>;
}
export declare namespace NewRedemptionSignerEvent {
    type InputTuple = [oldSigner: AddressLike, newSigner: AddressLike];
    type OutputTuple = [oldSigner: string, newSigner: string];
    interface OutputObject {
        oldSigner: string;
        newSigner: string;
    }
    type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
    type Filter = TypedDeferredTopicFilter<Event>;
    type Log = TypedEventLog<Event>;
    type LogDescription = TypedLogDescription<Event>;
}
export declare namespace RoleAdminChangedEvent {
    type InputTuple = [
        role: BytesLike,
        previousAdminRole: BytesLike,
        newAdminRole: BytesLike
    ];
    type OutputTuple = [
        role: string,
        previousAdminRole: string,
        newAdminRole: string
    ];
    interface OutputObject {
        role: string;
        previousAdminRole: string;
        newAdminRole: string;
    }
    type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
    type Filter = TypedDeferredTopicFilter<Event>;
    type Log = TypedEventLog<Event>;
    type LogDescription = TypedLogDescription<Event>;
}
export declare namespace RoleGrantedEvent {
    type InputTuple = [
        role: BytesLike,
        account: AddressLike,
        sender: AddressLike
    ];
    type OutputTuple = [role: string, account: string, sender: string];
    interface OutputObject {
        role: string;
        account: string;
        sender: string;
    }
    type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
    type Filter = TypedDeferredTopicFilter<Event>;
    type Log = TypedEventLog<Event>;
    type LogDescription = TypedLogDescription<Event>;
}
export declare namespace RoleRevokedEvent {
    type InputTuple = [
        role: BytesLike,
        account: AddressLike,
        sender: AddressLike
    ];
    type OutputTuple = [role: string, account: string, sender: string];
    interface OutputObject {
        role: string;
        account: string;
        sender: string;
    }
    type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
    type Filter = TypedDeferredTopicFilter<Event>;
    type Log = TypedEventLog<Event>;
    type LogDescription = TypedLogDescription<Event>;
}
export interface RedemptionManager extends BaseContract {
    connect(runner?: ContractRunner | null): RedemptionManager;
    waitForDeployment(): Promise<this>;
    interface: RedemptionManagerInterface;
    queryFilter<TCEvent extends TypedContractEvent>(event: TCEvent, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TypedEventLog<TCEvent>>>;
    queryFilter<TCEvent extends TypedContractEvent>(filter: TypedDeferredTopicFilter<TCEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TypedEventLog<TCEvent>>>;
    on<TCEvent extends TypedContractEvent>(event: TCEvent, listener: TypedListener<TCEvent>): Promise<this>;
    on<TCEvent extends TypedContractEvent>(filter: TypedDeferredTopicFilter<TCEvent>, listener: TypedListener<TCEvent>): Promise<this>;
    once<TCEvent extends TypedContractEvent>(event: TCEvent, listener: TypedListener<TCEvent>): Promise<this>;
    once<TCEvent extends TypedContractEvent>(filter: TypedDeferredTopicFilter<TCEvent>, listener: TypedListener<TCEvent>): Promise<this>;
    listeners<TCEvent extends TypedContractEvent>(event: TCEvent): Promise<Array<TypedListener<TCEvent>>>;
    listeners(eventName?: string): Promise<Array<Listener>>;
    removeAllListeners<TCEvent extends TypedContractEvent>(event?: TCEvent): Promise<this>;
    BETA: TypedContractMethod<[], [bigint], "view">;
    DECIMAL_PRECISION: TypedContractMethod<[], [bigint], "view">;
    DEFAULT_ADMIN_ROLE: TypedContractMethod<[], [string], "view">;
    MAX_BORROWING_FEE: TypedContractMethod<[], [bigint], "view">;
    MINUTE_DECAY_FACTOR: TypedContractMethod<[], [bigint], "view">;
    REDEMPTION_FEE_FLOOR: TypedContractMethod<[], [bigint], "view">;
    SECONDS_IN_ONE_MINUTE: TypedContractMethod<[], [bigint], "view">;
    baseRate: TypedContractMethod<[], [bigint], "view">;
    baseRateMap: TypedContractMethod<[arg0: AddressLike], [bigint], "view">;
    calcActualRepayAndSeize: TypedContractMethod<[
        redeemAmount: BigNumberish,
        provider: AddressLike,
        cToken: AddressLike,
        csuToken: AddressLike
    ], [
        [bigint, bigint, bigint, bigint]
    ], "nonpayable">;
    comptroller: TypedContractMethod<[], [string], "view">;
    decayBaseRateFromBorrowing: TypedContractMethod<[
        asset: AddressLike
    ], [
        void
    ], "nonpayable">;
    getCurrentRedemptionRate: TypedContractMethod<[
        asset: AddressLike,
        redeemAmount: BigNumberish,
        _totalSupply: BigNumberish
    ], [
        bigint
    ], "view">;
    getRedemptionRate: TypedContractMethod<[
        asset: AddressLike
    ], [
        bigint
    ], "view">;
    getRoleAdmin: TypedContractMethod<[role: BytesLike], [string], "view">;
    getRoleMember: TypedContractMethod<[
        role: BytesLike,
        index: BigNumberish
    ], [
        string
    ], "view">;
    getRoleMemberCount: TypedContractMethod<[role: BytesLike], [bigint], "view">;
    grantRole: TypedContractMethod<[
        role: BytesLike,
        account: AddressLike
    ], [
        void
    ], "nonpayable">;
    hasRole: TypedContractMethod<[
        role: BytesLike,
        account: AddressLike
    ], [
        boolean
    ], "view">;
    initialize: TypedContractMethod<[
        _admin: AddressLike,
        _redemptionSigner: AddressLike
    ], [
        void
    ], "nonpayable">;
    lastFeeOperationTime: TypedContractMethod<[], [bigint], "view">;
    lastFeeOperationTimeMap: TypedContractMethod<[
        arg0: AddressLike
    ], [
        bigint
    ], "view">;
    redeemFaceValue: TypedContractMethod<[
        csuToken: AddressLike,
        amount: BigNumberish,
        providers: AddressLike[],
        deadline: BigNumberish,
        signature: BytesLike
    ], [
        void
    ], "nonpayable">;
    redeemFaceValueWithPermit: TypedContractMethod<[
        csuToken: AddressLike,
        amount: BigNumberish,
        providers: AddressLike[],
        providersDeadline: BigNumberish,
        providersSignature: BytesLike,
        permitDeadline: BigNumberish,
        permitSignature: BytesLike
    ], [
        void
    ], "nonpayable">;
    redeemFaceValueWithProviderPreview: TypedContractMethod<[
        redeemer: AddressLike,
        provider: AddressLike,
        cToken: AddressLike,
        csuToken: AddressLike,
        redeemAmount: BigNumberish,
        redemptionRateMantissa: BigNumberish
    ], [
        [bigint, bigint, bigint, bigint, bigint, bigint]
    ], "nonpayable">;
    redemptionSigner: TypedContractMethod<[], [string], "view">;
    renounceRole: TypedContractMethod<[
        role: BytesLike,
        account: AddressLike
    ], [
        void
    ], "nonpayable">;
    revokeRole: TypedContractMethod<[
        role: BytesLike,
        account: AddressLike
    ], [
        void
    ], "nonpayable">;
    setComptroller: TypedContractMethod<[
        _comptroller: AddressLike
    ], [
        void
    ], "nonpayable">;
    setRedemptionSigner: TypedContractMethod<[
        signer: AddressLike
    ], [
        void
    ], "nonpayable">;
    supportsInterface: TypedContractMethod<[
        interfaceId: BytesLike
    ], [
        boolean
    ], "view">;
    getFunction<T extends ContractMethod = ContractMethod>(key: string | FunctionFragment): T;
    getFunction(nameOrSignature: "BETA"): TypedContractMethod<[], [bigint], "view">;
    getFunction(nameOrSignature: "DECIMAL_PRECISION"): TypedContractMethod<[], [bigint], "view">;
    getFunction(nameOrSignature: "DEFAULT_ADMIN_ROLE"): TypedContractMethod<[], [string], "view">;
    getFunction(nameOrSignature: "MAX_BORROWING_FEE"): TypedContractMethod<[], [bigint], "view">;
    getFunction(nameOrSignature: "MINUTE_DECAY_FACTOR"): TypedContractMethod<[], [bigint], "view">;
    getFunction(nameOrSignature: "REDEMPTION_FEE_FLOOR"): TypedContractMethod<[], [bigint], "view">;
    getFunction(nameOrSignature: "SECONDS_IN_ONE_MINUTE"): TypedContractMethod<[], [bigint], "view">;
    getFunction(nameOrSignature: "baseRate"): TypedContractMethod<[], [bigint], "view">;
    getFunction(nameOrSignature: "baseRateMap"): TypedContractMethod<[arg0: AddressLike], [bigint], "view">;
    getFunction(nameOrSignature: "calcActualRepayAndSeize"): TypedContractMethod<[
        redeemAmount: BigNumberish,
        provider: AddressLike,
        cToken: AddressLike,
        csuToken: AddressLike
    ], [
        [bigint, bigint, bigint, bigint]
    ], "nonpayable">;
    getFunction(nameOrSignature: "comptroller"): TypedContractMethod<[], [string], "view">;
    getFunction(nameOrSignature: "decayBaseRateFromBorrowing"): TypedContractMethod<[asset: AddressLike], [void], "nonpayable">;
    getFunction(nameOrSignature: "getCurrentRedemptionRate"): TypedContractMethod<[
        asset: AddressLike,
        redeemAmount: BigNumberish,
        _totalSupply: BigNumberish
    ], [
        bigint
    ], "view">;
    getFunction(nameOrSignature: "getRedemptionRate"): TypedContractMethod<[asset: AddressLike], [bigint], "view">;
    getFunction(nameOrSignature: "getRoleAdmin"): TypedContractMethod<[role: BytesLike], [string], "view">;
    getFunction(nameOrSignature: "getRoleMember"): TypedContractMethod<[
        role: BytesLike,
        index: BigNumberish
    ], [
        string
    ], "view">;
    getFunction(nameOrSignature: "getRoleMemberCount"): TypedContractMethod<[role: BytesLike], [bigint], "view">;
    getFunction(nameOrSignature: "grantRole"): TypedContractMethod<[
        role: BytesLike,
        account: AddressLike
    ], [
        void
    ], "nonpayable">;
    getFunction(nameOrSignature: "hasRole"): TypedContractMethod<[
        role: BytesLike,
        account: AddressLike
    ], [
        boolean
    ], "view">;
    getFunction(nameOrSignature: "initialize"): TypedContractMethod<[
        _admin: AddressLike,
        _redemptionSigner: AddressLike
    ], [
        void
    ], "nonpayable">;
    getFunction(nameOrSignature: "lastFeeOperationTime"): TypedContractMethod<[], [bigint], "view">;
    getFunction(nameOrSignature: "lastFeeOperationTimeMap"): TypedContractMethod<[arg0: AddressLike], [bigint], "view">;
    getFunction(nameOrSignature: "redeemFaceValue"): TypedContractMethod<[
        csuToken: AddressLike,
        amount: BigNumberish,
        providers: AddressLike[],
        deadline: BigNumberish,
        signature: BytesLike
    ], [
        void
    ], "nonpayable">;
    getFunction(nameOrSignature: "redeemFaceValueWithPermit"): TypedContractMethod<[
        csuToken: AddressLike,
        amount: BigNumberish,
        providers: AddressLike[],
        providersDeadline: BigNumberish,
        providersSignature: BytesLike,
        permitDeadline: BigNumberish,
        permitSignature: BytesLike
    ], [
        void
    ], "nonpayable">;
    getFunction(nameOrSignature: "redeemFaceValueWithProviderPreview"): TypedContractMethod<[
        redeemer: AddressLike,
        provider: AddressLike,
        cToken: AddressLike,
        csuToken: AddressLike,
        redeemAmount: BigNumberish,
        redemptionRateMantissa: BigNumberish
    ], [
        [bigint, bigint, bigint, bigint, bigint, bigint]
    ], "nonpayable">;
    getFunction(nameOrSignature: "redemptionSigner"): TypedContractMethod<[], [string], "view">;
    getFunction(nameOrSignature: "renounceRole"): TypedContractMethod<[
        role: BytesLike,
        account: AddressLike
    ], [
        void
    ], "nonpayable">;
    getFunction(nameOrSignature: "revokeRole"): TypedContractMethod<[
        role: BytesLike,
        account: AddressLike
    ], [
        void
    ], "nonpayable">;
    getFunction(nameOrSignature: "setComptroller"): TypedContractMethod<[_comptroller: AddressLike], [void], "nonpayable">;
    getFunction(nameOrSignature: "setRedemptionSigner"): TypedContractMethod<[signer: AddressLike], [void], "nonpayable">;
    getFunction(nameOrSignature: "supportsInterface"): TypedContractMethod<[interfaceId: BytesLike], [boolean], "view">;
    getEvent(key: "BaseRateUpdated"): TypedContractEvent<BaseRateUpdatedEvent.InputTuple, BaseRateUpdatedEvent.OutputTuple, BaseRateUpdatedEvent.OutputObject>;
    getEvent(key: "Initialized"): TypedContractEvent<InitializedEvent.InputTuple, InitializedEvent.OutputTuple, InitializedEvent.OutputObject>;
    getEvent(key: "LastFeeOpTimeUpdated"): TypedContractEvent<LastFeeOpTimeUpdatedEvent.InputTuple, LastFeeOpTimeUpdatedEvent.OutputTuple, LastFeeOpTimeUpdatedEvent.OutputObject>;
    getEvent(key: "NewComptroller"): TypedContractEvent<NewComptrollerEvent.InputTuple, NewComptrollerEvent.OutputTuple, NewComptrollerEvent.OutputObject>;
    getEvent(key: "NewRedemptionSigner"): TypedContractEvent<NewRedemptionSignerEvent.InputTuple, NewRedemptionSignerEvent.OutputTuple, NewRedemptionSignerEvent.OutputObject>;
    getEvent(key: "RoleAdminChanged"): TypedContractEvent<RoleAdminChangedEvent.InputTuple, RoleAdminChangedEvent.OutputTuple, RoleAdminChangedEvent.OutputObject>;
    getEvent(key: "RoleGranted"): TypedContractEvent<RoleGrantedEvent.InputTuple, RoleGrantedEvent.OutputTuple, RoleGrantedEvent.OutputObject>;
    getEvent(key: "RoleRevoked"): TypedContractEvent<RoleRevokedEvent.InputTuple, RoleRevokedEvent.OutputTuple, RoleRevokedEvent.OutputObject>;
    filters: {
        "BaseRateUpdated(address,uint256)": TypedContractEvent<BaseRateUpdatedEvent.InputTuple, BaseRateUpdatedEvent.OutputTuple, BaseRateUpdatedEvent.OutputObject>;
        BaseRateUpdated: TypedContractEvent<BaseRateUpdatedEvent.InputTuple, BaseRateUpdatedEvent.OutputTuple, BaseRateUpdatedEvent.OutputObject>;
        "Initialized(uint8)": TypedContractEvent<InitializedEvent.InputTuple, InitializedEvent.OutputTuple, InitializedEvent.OutputObject>;
        Initialized: TypedContractEvent<InitializedEvent.InputTuple, InitializedEvent.OutputTuple, InitializedEvent.OutputObject>;
        "LastFeeOpTimeUpdated(address,uint256)": TypedContractEvent<LastFeeOpTimeUpdatedEvent.InputTuple, LastFeeOpTimeUpdatedEvent.OutputTuple, LastFeeOpTimeUpdatedEvent.OutputObject>;
        LastFeeOpTimeUpdated: TypedContractEvent<LastFeeOpTimeUpdatedEvent.InputTuple, LastFeeOpTimeUpdatedEvent.OutputTuple, LastFeeOpTimeUpdatedEvent.OutputObject>;
        "NewComptroller(address,address)": TypedContractEvent<NewComptrollerEvent.InputTuple, NewComptrollerEvent.OutputTuple, NewComptrollerEvent.OutputObject>;
        NewComptroller: TypedContractEvent<NewComptrollerEvent.InputTuple, NewComptrollerEvent.OutputTuple, NewComptrollerEvent.OutputObject>;
        "NewRedemptionSigner(address,address)": TypedContractEvent<NewRedemptionSignerEvent.InputTuple, NewRedemptionSignerEvent.OutputTuple, NewRedemptionSignerEvent.OutputObject>;
        NewRedemptionSigner: TypedContractEvent<NewRedemptionSignerEvent.InputTuple, NewRedemptionSignerEvent.OutputTuple, NewRedemptionSignerEvent.OutputObject>;
        "RoleAdminChanged(bytes32,bytes32,bytes32)": TypedContractEvent<RoleAdminChangedEvent.InputTuple, RoleAdminChangedEvent.OutputTuple, RoleAdminChangedEvent.OutputObject>;
        RoleAdminChanged: TypedContractEvent<RoleAdminChangedEvent.InputTuple, RoleAdminChangedEvent.OutputTuple, RoleAdminChangedEvent.OutputObject>;
        "RoleGranted(bytes32,address,address)": TypedContractEvent<RoleGrantedEvent.InputTuple, RoleGrantedEvent.OutputTuple, RoleGrantedEvent.OutputObject>;
        RoleGranted: TypedContractEvent<RoleGrantedEvent.InputTuple, RoleGrantedEvent.OutputTuple, RoleGrantedEvent.OutputObject>;
        "RoleRevoked(bytes32,address,address)": TypedContractEvent<RoleRevokedEvent.InputTuple, RoleRevokedEvent.OutputTuple, RoleRevokedEvent.OutputObject>;
        RoleRevoked: TypedContractEvent<RoleRevokedEvent.InputTuple, RoleRevokedEvent.OutputTuple, RoleRevokedEvent.OutputObject>;
    };
}
