import type { BaseContract, BigNumberish, BytesLike, FunctionFragment, Result, Interface, AddressLike, ContractRunner, ContractMethod, Listener } from "ethers";
import type { TypedContractEvent, TypedDeferredTopicFilter, TypedEventLog, TypedListener, TypedContractMethod } from "../../../common";
export type LockedBalanceStruct = {
    amount: BigNumberish;
    end: BigNumberish;
};
export type LockedBalanceStructOutput = [amount: bigint, end: bigint] & {
    amount: bigint;
    end: bigint;
};
export interface VotingEscrowInterface extends Interface {
    getFunction(nameOrSignature: "balanceOf" | "locked" | "locked__end"): FunctionFragment;
    encodeFunctionData(functionFragment: "balanceOf", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "locked", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "locked__end", values: [AddressLike]): string;
    decodeFunctionResult(functionFragment: "balanceOf", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "locked", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "locked__end", data: BytesLike): Result;
}
export interface VotingEscrow extends BaseContract {
    connect(runner?: ContractRunner | null): VotingEscrow;
    waitForDeployment(): Promise<this>;
    interface: VotingEscrowInterface;
    queryFilter<TCEvent extends TypedContractEvent>(event: TCEvent, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TypedEventLog<TCEvent>>>;
    queryFilter<TCEvent extends TypedContractEvent>(filter: TypedDeferredTopicFilter<TCEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TypedEventLog<TCEvent>>>;
    on<TCEvent extends TypedContractEvent>(event: TCEvent, listener: TypedListener<TCEvent>): Promise<this>;
    on<TCEvent extends TypedContractEvent>(filter: TypedDeferredTopicFilter<TCEvent>, listener: TypedListener<TCEvent>): Promise<this>;
    once<TCEvent extends TypedContractEvent>(event: TCEvent, listener: TypedListener<TCEvent>): Promise<this>;
    once<TCEvent extends TypedContractEvent>(filter: TypedDeferredTopicFilter<TCEvent>, listener: TypedListener<TCEvent>): Promise<this>;
    listeners<TCEvent extends TypedContractEvent>(event: TCEvent): Promise<Array<TypedListener<TCEvent>>>;
    listeners(eventName?: string): Promise<Array<Listener>>;
    removeAllListeners<TCEvent extends TypedContractEvent>(event?: TCEvent): Promise<this>;
    balanceOf: TypedContractMethod<[addr: AddressLike], [bigint], "view">;
    locked: TypedContractMethod<[
        addr: AddressLike
    ], [
        LockedBalanceStructOutput
    ], "view">;
    locked__end: TypedContractMethod<[addr: AddressLike], [bigint], "view">;
    getFunction<T extends ContractMethod = ContractMethod>(key: string | FunctionFragment): T;
    getFunction(nameOrSignature: "balanceOf"): TypedContractMethod<[addr: AddressLike], [bigint], "view">;
    getFunction(nameOrSignature: "locked"): TypedContractMethod<[
        addr: AddressLike
    ], [
        LockedBalanceStructOutput
    ], "view">;
    getFunction(nameOrSignature: "locked__end"): TypedContractMethod<[addr: AddressLike], [bigint], "view">;
    filters: {};
}
