import { type ContractRunner } from "ethers";
import type { IAaveV3Pool, IAaveV3PoolInterface } from "../../../../contracts/CToken/CAToken.sol/IAaveV3Pool";
export declare class IAaveV3Pool__factory {
    static readonly abi: readonly [{
        readonly inputs: readonly [{
            readonly internalType: "address";
            readonly name: "asset";
            readonly type: "address";
        }];
        readonly name: "getReserveData";
        readonly outputs: readonly [{
            readonly components: readonly [{
                readonly components: readonly [{
                    readonly internalType: "uint256";
                    readonly name: "data";
                    readonly type: "uint256";
                }];
                readonly internalType: "struct IAaveV3Pool.ReserveConfigurationMap";
                readonly name: "configuration";
                readonly type: "tuple";
            }, {
                readonly internalType: "uint128";
                readonly name: "liquidityIndex";
                readonly type: "uint128";
            }, {
                readonly internalType: "uint128";
                readonly name: "currentLiquidityRate";
                readonly type: "uint128";
            }, {
                readonly internalType: "uint128";
                readonly name: "variableBorrowIndex";
                readonly type: "uint128";
            }, {
                readonly internalType: "uint128";
                readonly name: "currentVariableBorrowRate";
                readonly type: "uint128";
            }, {
                readonly internalType: "uint128";
                readonly name: "currentStableBorrowRate";
                readonly type: "uint128";
            }, {
                readonly internalType: "uint40";
                readonly name: "lastUpdateTimestamp";
                readonly type: "uint40";
            }, {
                readonly internalType: "uint16";
                readonly name: "id";
                readonly type: "uint16";
            }, {
                readonly internalType: "address";
                readonly name: "aTokenAddress";
                readonly type: "address";
            }, {
                readonly internalType: "address";
                readonly name: "stableDebtTokenAddress";
                readonly type: "address";
            }, {
                readonly internalType: "address";
                readonly name: "variableDebtTokenAddress";
                readonly type: "address";
            }, {
                readonly internalType: "address";
                readonly name: "interestRateStrategyAddress";
                readonly type: "address";
            }, {
                readonly internalType: "uint128";
                readonly name: "accruedToTreasury";
                readonly type: "uint128";
            }, {
                readonly internalType: "uint128";
                readonly name: "unbacked";
                readonly type: "uint128";
            }, {
                readonly internalType: "uint128";
                readonly name: "isolationModeTotalDebt";
                readonly type: "uint128";
            }];
            readonly internalType: "struct IAaveV3Pool.ReserveData";
            readonly name: "";
            readonly type: "tuple";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "address";
            readonly name: "underlyingAsset";
            readonly type: "address";
        }];
        readonly name: "getReserveNormalizedIncome";
        readonly outputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "";
            readonly type: "uint256";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "address";
            readonly name: "asset";
            readonly type: "address";
        }, {
            readonly internalType: "uint256";
            readonly name: "amount";
            readonly type: "uint256";
        }, {
            readonly internalType: "address";
            readonly name: "onBehalfOf";
            readonly type: "address";
        }, {
            readonly internalType: "uint16";
            readonly name: "referralCode";
            readonly type: "uint16";
        }];
        readonly name: "supply";
        readonly outputs: readonly [];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "address";
            readonly name: "asset";
            readonly type: "address";
        }, {
            readonly internalType: "uint256";
            readonly name: "amount";
            readonly type: "uint256";
        }, {
            readonly internalType: "address";
            readonly name: "to";
            readonly type: "address";
        }];
        readonly name: "withdraw";
        readonly outputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "";
            readonly type: "uint256";
        }];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }];
    static createInterface(): IAaveV3PoolInterface;
    static connect(address: string, runner?: ContractRunner | null): IAaveV3Pool;
}
