import { ContractFactory, ContractTransactionResponse } from "ethers";
import type { Signer, ContractDeployTransaction, ContractRunner } from "ethers";
import type { NonPayableOverrides } from "../../../../common";
import type { VaultReentrancyLib, VaultReentrancyLibInterface } from "../../../../contracts/Infrared/VaultReentrancyLib.sol/VaultReentrancyLib";
type VaultReentrancyLibConstructorParams = [signer?: Signer] | ConstructorParameters<typeof ContractFactory>;
export declare class VaultReentrancyLib__factory extends ContractFactory {
    constructor(...args: VaultReentrancyLibConstructorParams);
    getDeployTransaction(overrides?: NonPayableOverrides & {
        from?: string;
    }): Promise<ContractDeployTransaction>;
    deploy(overrides?: NonPayableOverrides & {
        from?: string;
    }): Promise<VaultReentrancyLib & {
        deploymentTransaction(): ContractTransactionResponse;
    }>;
    connect(runner: ContractRunner | null): VaultReentrancyLib__factory;
    static readonly bytecode = "0x60808060405234601757603a9081601d823930815050f35b600080fdfe600080fdfea2646970667358221220fbd8a3f2f7170e476bd146eaceae2e791e0e804f98fcc5e0a2d22bc911a05b3f64736f6c634300081a0033";
    static readonly abi: readonly [{
        readonly inputs: readonly [];
        readonly name: "Reentry";
        readonly type: "error";
    }];
    static createInterface(): VaultReentrancyLibInterface;
    static connect(address: string, runner?: ContractRunner | null): VaultReentrancyLib;
}
export {};
