import { type ContractRunner } from "ethers";
import type { IGovernorBravo, IGovernorBravoInterface } from "../../../contracts/Interfaces/IGovernorBravo";
export declare class IGovernorBravo__factory {
    static readonly abi: readonly [{
        readonly inputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "proposalId";
            readonly type: "uint256";
        }];
        readonly name: "getActions";
        readonly outputs: readonly [{
            readonly internalType: "address[]";
            readonly name: "targets";
            readonly type: "address[]";
        }, {
            readonly internalType: "uint256[]";
            readonly name: "values";
            readonly type: "uint256[]";
        }, {
            readonly internalType: "string[]";
            readonly name: "signatures";
            readonly type: "string[]";
        }, {
            readonly internalType: "bytes[]";
            readonly name: "calldatas";
            readonly type: "bytes[]";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "proposalId";
            readonly type: "uint256";
        }, {
            readonly internalType: "address";
            readonly name: "voter";
            readonly type: "address";
        }];
        readonly name: "getReceipt";
        readonly outputs: readonly [{
            readonly components: readonly [{
                readonly internalType: "bool";
                readonly name: "hasVoted";
                readonly type: "bool";
            }, {
                readonly internalType: "uint8";
                readonly name: "support";
                readonly type: "uint8";
            }, {
                readonly internalType: "uint96";
                readonly name: "votes";
                readonly type: "uint96";
            }];
            readonly internalType: "struct IGovernorBravo.Receipt";
            readonly name: "";
            readonly type: "tuple";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "proposalId";
            readonly type: "uint256";
        }];
        readonly name: "proposals";
        readonly outputs: readonly [{
            readonly components: readonly [{
                readonly internalType: "uint256";
                readonly name: "id";
                readonly type: "uint256";
            }, {
                readonly internalType: "address";
                readonly name: "proposer";
                readonly type: "address";
            }, {
                readonly internalType: "uint256";
                readonly name: "eta";
                readonly type: "uint256";
            }, {
                readonly internalType: "uint256";
                readonly name: "startBlock";
                readonly type: "uint256";
            }, {
                readonly internalType: "uint256";
                readonly name: "endBlock";
                readonly type: "uint256";
            }, {
                readonly internalType: "uint256";
                readonly name: "forVotes";
                readonly type: "uint256";
            }, {
                readonly internalType: "uint256";
                readonly name: "againstVotes";
                readonly type: "uint256";
            }, {
                readonly internalType: "uint256";
                readonly name: "abstainVotes";
                readonly type: "uint256";
            }, {
                readonly internalType: "bool";
                readonly name: "canceled";
                readonly type: "bool";
            }, {
                readonly internalType: "bool";
                readonly name: "executed";
                readonly type: "bool";
            }];
            readonly internalType: "struct IGovernorBravo.Proposal";
            readonly name: "";
            readonly type: "tuple";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }];
    static createInterface(): IGovernorBravoInterface;
    static connect(address: string, runner?: ContractRunner | null): IGovernorBravo;
}
