import { type ContractRunner } from "ethers";
import type { IVault, IVaultInterface } from "../../../contracts/Interfaces/IVault";
export declare class IVault__factory {
    static readonly abi: readonly [{
        readonly inputs: readonly [{
            readonly internalType: "bytes32";
            readonly name: "poolId";
            readonly type: "bytes32";
        }];
        readonly name: "getPoolTokens";
        readonly outputs: readonly [{
            readonly internalType: "address[]";
            readonly name: "tokens";
            readonly type: "address[]";
        }, {
            readonly internalType: "uint256[]";
            readonly name: "balances";
            readonly type: "uint256[]";
        }, {
            readonly internalType: "uint256";
            readonly name: "lastChangeBlock";
            readonly type: "uint256";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly components: readonly [{
                readonly internalType: "enum IVault.UserBalanceOpKind";
                readonly name: "kind";
                readonly type: "uint8";
            }, {
                readonly internalType: "contract IAsset";
                readonly name: "asset";
                readonly type: "address";
            }, {
                readonly internalType: "uint256";
                readonly name: "amount";
                readonly type: "uint256";
            }, {
                readonly internalType: "address";
                readonly name: "sender";
                readonly type: "address";
            }, {
                readonly internalType: "address payable";
                readonly name: "recipient";
                readonly type: "address";
            }];
            readonly internalType: "struct IVault.UserBalanceOp[]";
            readonly name: "ops";
            readonly type: "tuple[]";
        }];
        readonly name: "manageUserBalance";
        readonly outputs: readonly [];
        readonly stateMutability: "payable";
        readonly type: "function";
    }];
    static createInterface(): IVaultInterface;
    static connect(address: string, runner?: ContractRunner | null): IVault;
}
