import { ContractFactory, ContractTransactionResponse } from "ethers";
import type { Signer, ContractDeployTransaction, ContractRunner } from "ethers";
import type { NonPayableOverrides } from "../../common";
import type { SumerErrors, SumerErrorsInterface } from "../../contracts/SumerErrors";
type SumerErrorsConstructorParams = [signer?: Signer] | ConstructorParameters<typeof ContractFactory>;
export declare class SumerErrors__factory extends ContractFactory {
    constructor(...args: SumerErrorsConstructorParams);
    getDeployTransaction(overrides?: NonPayableOverrides & {
        from?: string;
    }): Promise<ContractDeployTransaction>;
    deploy(overrides?: NonPayableOverrides & {
        from?: string;
    }): Promise<SumerErrors & {
        deploymentTransaction(): ContractTransactionResponse;
    }>;
    connect(runner: ContractRunner | null): SumerErrors__factory;
    static readonly bytecode = "0x60808060405234601357603a908160198239f35b600080fdfe600080fdfea2646970667358221220e8bef91c4d6446b59d163b8ec8dfb5baf42e9f09c764311b4d1f7aee7e65b6b364736f6c634300081a0033";
    static readonly abi: readonly [{
        readonly inputs: readonly [];
        readonly name: "AddReservesMarketNotFresh";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "AddReservesOverflow";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "BorrowAndDepositBackFailed";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "BorrowCapReached";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "BorrowCashNotAvailable";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "BorrowMarketNotFresh";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "BorrowPaused";
        readonly type: "error";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "usdThreshold";
            readonly type: "uint256";
        }];
        readonly name: "BorrowValueMustBeLargerThanThreshold";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "CantEnterPausedMarket";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "CantExitMarketWithNonZeroBorrowBalance";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "CantSweepUnderlying";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "ComptrollerMismatch";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "EitherAssetOrDebtMustBeZero";
        readonly type: "error";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint8";
            readonly name: "groupId";
            readonly type: "uint8";
        }, {
            readonly internalType: "uint256";
            readonly name: "cDepositVal";
            readonly type: "uint256";
        }, {
            readonly internalType: "uint256";
            readonly name: "suDepositVal";
            readonly type: "uint256";
        }, {
            readonly internalType: "uint256";
            readonly name: "cBorrowVal";
            readonly type: "uint256";
        }, {
            readonly internalType: "uint256";
            readonly name: "suBorrowVal";
            readonly type: "uint256";
        }];
        readonly name: "EitherAssetOrDebtMustBeZeroInGroup";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "ExpiredSignature";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InsufficientCollateral";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InsufficientShortfall";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InterMintNotAllowed";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InvalidAddress";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InvalidAmount";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InvalidBlockNumber";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InvalidCToken";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InvalidCloseFactor";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InvalidComptroller";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InvalidDiscountRate";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InvalidExchangeRate";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InvalidGroupId";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InvalidInput";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InvalidInterestRateModel";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InvalidMinSuBorrowValue";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InvalidRedeem";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InvalidReduceAmount";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InvalidReserveFactor";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InvalidSignatureForRedeemFaceValue";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InvalidSignatureLength";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InvalidSuToken";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "InvalidTimestamp";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "LiquidateBorrow_LiquidatorIsBorrower";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "LiquidateBorrow_RepayAmountIsMax";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "LiquidateBorrow_RepayAmountIsZero";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "LiquidateBorrow_SeizeTooMuch";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "LiquidateCollateralMarketNotFresh";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "LiquidateMarketNotFresh";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "MarketAlreadyListed";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "MarketAlreadyUnlisted";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "MarketCanOnlyInitializeOnce";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "MarketNotEmpty";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "MarketNotListed";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "MarketPaused";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "MinDelayNotReached";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "MintMarketNotFresh";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "MintPaused";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "MintTokensCantBeZero";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "NoRedemptionProvider";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "NotCToken";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "NotEnoughForSeize";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "NotEnoughRedeemAmount";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "NotEnoughRedeemTokens";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "NotEnoughUnderlyingAfterRedeem";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "NotEnoughUnderlyingForMint";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "NotLiquidatableYet";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "NotSuToken";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "OnlyAdmin";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "OnlyAdminOrPauser";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "OnlyCToken";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "OnlyListedCToken";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "OnlyPausedMarketCanBeUnlisted";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "OnlyPendingAdmin";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "OnlyRedemptionManager";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "OverThreshold";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "PriceError";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "ProtectedMint_OnlyAllowAssetsInTheSameGroup";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "RedeemMarketNotFresh";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "RedeemTransferOutNotPossible";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "RedemptionSeizeTooMuch";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "RedemptionSignerNotInitialized";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "ReduceReservesCashNotAvailable";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "ReduceReservesMarketNotFresh";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "Reentered";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "RepayBorrowMarketNotFresh";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "RepayTokenNotListed";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "SeizePaused";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "SeizeTokenNotListed";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "Seize_LiquidatorIsBorrower";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "SenderMustBeCToken";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "SetInterestRateModelMarketNotFresh";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "SetReservesFactorMarketNotFresh";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "SupplyCapReached";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "TokenInOrAmountInMustBeZero";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "TokenTransferInFailed";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "TokenTransferOutFailed";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "TooMuchRepay";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "TotalBorrowsNotZero";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "TotalSupplyNotZero";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "TransferNotAllowed";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "TransferPaused";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "UnderlyingBalanceError";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "ZeroAddressNotAllowed";
        readonly type: "error";
    }];
    static createInterface(): SumerErrorsInterface;
    static connect(address: string, runner?: ContractRunner | null): SumerErrors;
}
export {};
